﻿package com.castledragmire.GPSMapping;

//GUI
import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.TextView;
import android.widget.Button;
import android.widget.ToggleButton;
import android.widget.CompoundButton;
import android.widget.CompoundButton.OnCheckedChangeListener;
import android.view.View.OnClickListener;
//Settings
import android.view.Menu;
import android.view.MenuItem;
import android.content.SharedPreferences;

public class GPSMapping extends Activity
{
	//GUI
	public TextView CurrentPosition;
	private ToggleButton IsEnabled;

	//Activity functions
	@Override public void onCreate(Bundle savedInstanceState) //Initialization
	{
		//Prepare the GUI
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);
		CurrentPosition=(TextView)findViewById(R.id.CurrentPosition);
		IsEnabled=(ToggleButton)findViewById(R.id.IsEnabled);
		IsEnabled.setChecked(getSharedPreferences("MyPrefs", 0).getBoolean("IsEnabled", true));
		IsEnabled.setOnCheckedChangeListener(IsEnabled_CheckChanged);
		((Button)findViewById(R.id.SettingsButton)).setOnClickListener(new OnClickListener() { @Override public void onClick(View v) {
			startActivity(new Intent(GPSMapping.this, Settings.class));
		}});

		//Start the service if needed
		GPSMappingService.UpdateVariables(false, this);
	}

	@Override protected void onResume() //Set the last update text
	{
		super.onResume();

		//Interact with the service
		GPSMappingService.GPSMappingGUI=this;
		CurrentPosition.setText(GPSMappingService.LastUpdate);
	}

	@Override protected void onStop() //Make service no longer interact with this GUI
	{
		GPSMappingService.GPSMappingGUI=null;
		super.onStop();
	}

	//IsEnabled button
	private OnCheckedChangeListener IsEnabled_CheckChanged=new OnCheckedChangeListener() { @Override public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
		//Store the setting
		SharedPreferences MyPrefs=getSharedPreferences("MyPrefs", 0);
		MyPrefs.edit().putBoolean("IsEnabled", isChecked).commit();

		//Start or stop the service accordingly
		if(isChecked && MyPrefs.getBoolean("AllSettingsValid", false))
			GPSMappingService.UpdateVariables(false, GPSMapping.this);
		else
			GPSMappingService.StopService(GPSMapping.this);
	} };

	//Menu
	@Override public boolean onCreateOptionsMenu(Menu menu) //Create the options menu
	{
		menu.add(0, 0, 0, getString(R.string.Main_Title_Settings));
		return true;
	}

	@Override public boolean onOptionsItemSelected(MenuItem item) //Handle menu selection
	{
		startActivity(new Intent(this, Settings.class));
		return true;
	}
}