<?
//If the browser has a valid cache of the image, return to use the cache (304)
$LastModifiedTime=filemtime(substr(strrchr($_SERVER['SCRIPT_NAME'],'/'),1)); //Determine the modification time of this file
$LastModifiedString=gmdate('D, d M Y H:i:s', $LastModifiedTime). ' GMT'; //The string representation of the modification time of this file
if(isset($_SERVER['HTTP_IF_MODIFIED_SINCE']) && strtotime($_SERVER['HTTP_IF_MODIFIED_SINCE'])==$LastModifiedTime)
{
	header('Last-Modified: '.$LastModifiedString, true, 304);
	exit;
}

//Determine the output string
$OutputString='E'; //Error unless number is valid
if(isset($_REQUEST['Num']) && preg_match('/^\d{1,3}$/D', $_REQUEST['Num'])==1 && intval($_REQUEST['Num'])!=0) //If a number in the range 1-999, use it
	$OutputString=$_REQUEST['Num'];

//Prepare the image canvas
$Img=imagecreatefrompng('Res/Icon'.strlen($OutputString).'.png');
imagealphablending($Img, true);
imagesavealpha($Img, true);

//Draw the text
$FontName='Res/verdana.ttf';
$FontSize=12-strlen($OutputString);
$StringBox=imagettfbbox($FontSize, 0, $FontName, $OutputString);
imagettftext($Img, $FontSize, 0, (30-($StringBox[4]-$StringBox[6]))/2, 7-$StringBox[7], imagecolorallocatealpha($Img, 255, 255, 255, 32), $FontName, $OutputString);

//Get the image output
ob_start();
imagepng($Img);
imagedestroy($Img);
$ImageData=ob_get_contents();
ob_end_clean();

//Output the image
header('Content-type: image/png');
header('Last-Modified: '.$LastModifiedString);
header('Content-Length: '.strlen($ImageData));
print $ImageData;
?>